//************************************************************************
//
//	Coordinator.m  
//		
//		NXApp delegate, central control object for GateKeeper 
// 
//			by	Felipe A. Rodriguez		
//
//	The base for this file was:
//	
//			Coordinator.m
//			by Joe Freeman, David LaVallee
//			Subprocess Example, Release 2.0
//			NeXT Computer, Inc.
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//************************************************************************

#import <objc/Object.h>
#import <appkit/Application.h>
#import <appkit/nextstd.h>


@interface Coordinator:Object
{
	id  theIconView;
	id  theAnimator;
	id  onImage;			// pointer to our "linked" tiff
	NXRect bRect;
	id  timeCell;
    id	commandView;
    id	statusView;
    id	diagWin;
    id	statusWin;
    id	connectionSpeedField;
    id	timeField;
    id	localIPField;
    id	remoteIPField;
    id	providerField;
    id	statusButton;
    id	linkMenuButton;
    id	dial;
    id  infoPanel;			/* The Info... panel */
    id  helpPanel;			/* outlet to our help panel */
    id  prefPanel;			/* The Preferences panel */
	id	theSubprocess;
    id	stringTable;
	id  theTimer;
	id  theOpenButton;
	id  theGateDocEditor;
	id  theOptionsEditor;
	BOOL userWantsTermination;	// subprocess fail should not kill GateKeeper
	char lastCall[MAXPATHLEN + 1];	 // stores path of last .Gate doc invoked
	id theGateServer;			// distributed objects server
	id GateConnection;			// distributed objects server
	char Path[MAXPATHLEN + 1];	// generic buffer to hold paths
	char BPath[MAXPATHLEN + 1];	// generic buffer to hold paths
	time_t ltime;				// time used in producing a startup delay
	int numEntries[10];
	id  strHashTable;			// keywords hashtable used in detecting link up
	id  toolBar;				// our tool bar 
    char *capturedStr[4];		// ptr array to address str's and baud str
	id  iTimer;					// the Inacitivity Timer/pppstats controller 
	id  Parser;					// pattern search object
	int linkStg;				// stage of ppp link
	int backOffDelay;			// delay to backoff on consecutive redials
	int backOffDefault;			// backoff delay default value
	id  hotListDelegate;		// hotlist window's delegate
	BOOL appIconTime;			// display online time in app icon
}

- showInfo:sender;
- preferences:sender;
- showHelpPanel:sender;
- showStatusPanel:sender; 
- showDiagWin:sender;
- showTimerPanel:sender; 

- Dial:sender;  
- DOFinished;
- Link:sender;  
- UnLink:sender;  
- (BOOL)appAcceptsAnotherFile:sender; 
- showMenuTimer:(char *)buffer; 
- gotIt;
- displayLinkStatus;
- analyzeBuffer:(char *)buffer;
- syslogdReset;
- syslogdRun;
- DialOnDemand;
- namedReset:(const char *)buffer;
- namedDod;
- fifo;
- toolBar:sender;
- setTimeout:(int)minTillTimeout; 
- readable:(const char *)nameOfFile;
- optionsEditor;
- appIconView;
- (BOOL)mailInQueue; 
- runScript:(const char *)type;  
- redial:sender;
- resetDelay:sender;
- connectedAt:(const char *)speed;  
- linkWithFile:(const char *)path;  
- (const char *)extractName:(const char *)aPath;
- (BOOL)debugFlag:(const char *)optionFile;
- hotListDelegate; 
- updateBrowser:sender;
- setAppIconTimer:(BOOL)onOff; 
- stringTable;
- showAlert:(const char *)errorString;
- (const char *)localString:(const char *)aString;

	// Subprocess Delegation
- subprocessOutput:(char *)buffer;
- subprocessDone;

	// Application Object Delegation
- appDidInit:sender;
- appWillTerminate:sender;
- (int)app:sender openFile:(const char *)path type:(const char *)type; 
- (BOOL)appAcceptsAnotherFile:sender; 

	// Window Object Delegation
- windowWillMiniaturize:sender toMiniwindow:miniwindow; 

@end

