//*****************************************************************************
//
//	InactivityTimer.h.  	
//
//	Tracks and determines whether inactivity timeout is warranted
//
//		by	Felipe A. Rodriguez		
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//*****************************************************************************



#import <appkit/appkit.h>

@interface InactivityTimer:Object
{
	int  timeout;				// timeout in minutes
	int iBaseCntr;				// inactivity timeout base counter
	int iPeriodCntr;			// number of inactive periods measured
	BOOL posNI;					// possibly non-interactive session? ivar
	BOOL pppstats;				// whether pppstats is enabled and socket open
	id commandView;
	id sView;
	id mailView;
    id ITPanel;					// inactivity timeout panel
	BOOL wasHidden;				// whether the app was hidden when called
	BOOL preTimeout;			// whether pre timeout is enabled
	int iTimeThresh;			// inactivity timeout threshold
	id imageList;
}

- init;
- setTimeout:(int)minTillTimeout; 
- inactivityTimeout;
- resetInactivityTimer;
- setPosNonInter:(BOOL)pni; 
- (BOOL)posNonInter; 
- pppstats:aView;
- pppstatsReset;
- cancel:sender;
- continue:sender;
- setMailIconAnim;
- _animate;
- removeTimedEntry;

@end
