//*****************************************************************************
//
//	SecondPreference.m.  
//
//		Preferences logic.
//
//			by	Felipe A. Rodriguez		
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//*****************************************************************************

#import "../SwapView.h"
#import "SecondPreference.h"
#import "SecondPanelController.h"

#define BUTTONPOSITION 1




@implementation SecondPreference 

//*****************************************************************************
//
// 		recieved immediately after class is dynamically loaded 
//
//*****************************************************************************

+ finishLoading:(struct mach_header *)header
{
	[self poseAs:[self superclass]];

	return self;
}
//*****************************************************************************
//
//		sent to us after nib objects are unarchived and init'd 
//
//*****************************************************************************
 
- awakeFromNib
{
NXImage *image = [NXImage findImageNamed:"app"];

	[super awakeFromNib];
								// find button image
	strncpy(Path, [[NXBundle mainBundle] directory] , MAXPATHLEN);	
	strncat(Path, "/Defaults",MAXPATHLEN - strlen(Path));
	strncat(Path, ".gkPreference/icon.tiff", MAXPATHLEN - strlen(Path));
	image = [[NXImage alloc] initFromFile:Path];

								// add a selector button for this inspector
	if([bView cellCount] <= BUTTONPOSITION)
		[bView insertColAt:BUTTONPOSITION];
	[super resizeScrollViewFor:BUTTONPOSITION];
	[[[[[bView cellAt:0 :BUTTONPOSITION]
						setImage:image]
						setTag:BUTTONPOSITION]
						setTarget:self]
						setAction:@selector(displaySecond:)];
	[bView display];
	
    return self;
}
//*****************************************************************************
//
//		swap preferences subviews, dynamically load ours if necessary
//
//*****************************************************************************

- displaySecond:sender 
{
	[self loadPreference:"SecondPanelController" 
				 ofClass:[SecondPanelController class] 
				 buttonMatrix:sender];
				 
    return self;
}

@end

